<?php

namespace FiloBlu\Refilo\Controller\Adminhtml\Exporter;

use Exception;
use Magento\Framework\App\Action\HttpGetActionInterface as HttpGetActionInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Message\ManagerInterface;
use FiloBlu\Refilo\Model\Exporter\Storelocator as StorelocatorExporter;

class Storelocator implements HttpGetActionInterface
{
    /**
     * @var
     */
    private $messageManager;
    /**
     * @var ResultFactory
     */
    private $resultFactory;
    /**
     * @var StorelocatorExporter
     */
    private $storelocatorExporter;

    /**
     * Countries constructor.
     * @param ResultFactory $resultFactory
     * @param ManagerInterface $messageManager
     * @param StorelocatorExporter $storelocatorExporter
     */
    public function __construct(
        ResultFactory $resultFactory,
        ManagerInterface $messageManager,
        StorelocatorExporter $storelocatorExporter
    ) {
        $this->resultFactory = $resultFactory;
        $this->messageManager = $messageManager;
        $this->storelocatorExporter = $storelocatorExporter;
    }

    public function execute()
    {
        try {
            //@ToDo Reimplement it as query as soon as a solution for regions is found
            $this->storelocatorExporter->exportStores();
            $this->messageManager->addSuccessMessage(__('Storelocator data successfully synced with MongoDB'));
        } catch (Exception $e) {
            $this->messageManager->addExceptionMessage($e);
        }

        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath('indexer/indexer/list/');
    }

}
